(function($) {
	$.fn.cpdonation = function() {
		return this.each(function() {

			// Donation widget elements
			var widget = $(this);
			var itemNameEl = $(this).find('.item_name');
			var amountEl = $(this).find('.amount');
			var url_ada = $(this).find('.url');
			var expiration_time1 = $(this).find('.expiration_time');
			var api_key1 = $(this).find('.api_key');
			
			var amount2El = $(this).find('.amount2');
			var fixedAmountEl = $(this).find('.fixed-amount');
			var additionalFixedEl = $(this).find('.additional-fixed');
			var quantityEl = $(this).find('.quantity');
			var categoryEl = $(this).find('.donation_category');
			var commentsEl = $(this).find('.comments');
			
			var totalAmountEl = $(this).find('.total_amt');
			var submitButton = $(this).find('.adaSubmit');
			var cpQuantityEl = $(this).find('.cp_quantity');
			
			// Default values
			var itemName = itemNameEl.val();
			var defaultDonation = fixedAmountEl.html();	
			var q = 0;
			
			if(additionalFixedEl) {
				var additionalFixed = parseFloat(additionalFixedEl.html());
				if(!isNaN(additionalFixed)) {
					var initialAmount = parseFloat(defaultDonation) + additionalFixed;
					totalAmountEl.html(initialAmount);
					amountEl.val(initialAmount);
				}
			}



			amountEl.on('keydown', function(e){if(!((e.keyCode > 47 && e.keyCode < 59) || ( e.keyCode >= 96 && e.keyCode <= 105 ||  e.keyCode == 110 || e.keyCode == 190) || e.keyCode == 8)){e.preventDefault();}});
			
			// Type 1
			amountEl.on('keyup', function(){											   
			var donation = amountEl.val();
			
			if(!isNaN(donation)){
				var total = donation;
				amountEl.val(total);
				totalAmountEl.html(total);
				if(additionalFixedEl) {
					if(!isNaN(additionalFixed)) {							
						total = total + additionalFixed;
						totalAmountEl.html(total);
						amountEl.val(total);
					}
				}
				}else{
					totalAmountEl.html(defaultDonation);
				} 
			});
			
			//Type 2
			amount2El.on('keyup', function(){ 	  
				var donation = parseFloat(fixedAmountEl.html());
				var quantity = (q != 0) ? q : 1;
				var additionalDonation = parseFloat(amount2El.val());
				if(!isNaN(additionalDonation)){
					var total = additionalDonation+(donation*quantity);
					amountEl.val(total);
					totalAmountEl.html(total);
					if(additionalFixedEl) {
						if(!isNaN(additionalFixed)) {							
							total = total + additionalFixed;
							totalAmountEl.html(total);
							amountEl.val(total);
						}
					}
				}else{
					totalAmountEl.html(defaultDonation);
				}	
			});
			
			//Type 3 and Type 4
			quantityEl.change(function(){ 				  
				//amount2El.val('');						
				var quantity = (parseFloat($(this).find('option:selected').val()) > 1) ? parseFloat($(this).find('option:selected').val()) : 1;
				q = quantity;
				if(!isNaN(quantity)){
					var total = quantity*parseFloat(fixedAmountEl.html())+amount2El.val()*1;
					cpQuantityEl.val(quantity);
					if(additionalFixedEl) {
						additionalFixed = parseFloat(additionalFixedEl.html());
						if(!isNaN(additionalFixed)) {
							total = total + additionalFixed;
						}
					}
					amountEl.val(total);
					totalAmountEl.html(total);
				}else{
					totalAmountEl.html(defaultDonation);
				}	
			});
			
			//Submit
			submitButton.on('click', function() {
				

				// var amount = amountEl.val() * 1098901.098901099;
				// var url = url_ada.val();
				// var expiration_time = expiration_time1.val();
				// var api_key = api_key1.val();

				// // function make_base_auth(api_key) {
				 
				// //   return "Bearer  " + api_key;
				// // }

				// $.ajax({
				//   url: url+"/"+"payment-request",
				//   type: 'PUT',
				//   // Fetch the stored token from localStorage and set in the header
				//   headers: {Accept: "application/json",'Access-Control-Allow-Origin': '*','Access-Control-Allow-Headers': 'Content-Type','Access-Control-Allow-Methods': 'GET,POST,OPTIONS,DELETE,PUT'},
    //               contentType: 'application/json',
    //               dataType: 'application/json',
    //               cors: true ,
    //                secure: true,
    //               data: JSON.stringify( { "amount": amount, "paymentRequestExpirationTime": expiration_time, "receiptEmail" : 'test@test.com', "returnUrl":'https://google.com' } )

				// 	,
				// 	beforeSend: function (xhr) {
		  //           xhr.setRequestHeader ("Authorization", "Bearer " +api_key);
		  //         },
				//    success: function (result, status, xhr) {
				//        alert(result);
				//     },
				// });



				var quantity = cpQuantityEl.val();
				if (quantity != '0') {
					itemNameEl.val(itemName + ' (quantity ' + quantity + ')');	
				}
				if(typeof(categoryEl.val()) != 'undefined') {
					var tempName = itemNameEl.val();
					itemNameEl.val(tempName + ' Category: ' + categoryEl.val());
				}
				if(typeof(commentsEl.val()) != 'undefined') {
					var tempName = itemNameEl.val();
					itemNameEl.val(tempName + ' Comments: ' + commentsEl.val());
				}
				widget.submit();										 
			});
		});
	}
})(jQuery);

jQuery(document).ready(function() {
	jQuery('.cpDonation').cpdonation();
});